package product_getRecommendName_request

import (
	"encoding/json"
	product_getRecommendName_response "git.rosy.net.cn/baseapi/platformapi/tiktok_shop/sdk-golang/api/product_getRecommendName/response"
	doudian_sdk "git.rosy.net.cn/baseapi/platformapi/tiktok_shop/sdk-golang/core"
)

type ProductGetRecommendNameRequest struct {
	doudian_sdk.BaseDoudianOpApiRequest
	Param *ProductGetRecommendNameParam
}

func (c *ProductGetRecommendNameRequest) GetUrlPath() string {
	return "/product/getRecommendName"
}

func New() *ProductGetRecommendNameRequest {
	request := &ProductGetRecommendNameRequest{
		Param: &ProductGetRecommendNameParam{},
	}
	request.SetConfig(doudian_sdk.GlobalConfig)
	request.SetClient(doudian_sdk.DefaultDoudianOpApiClient)
	return request

}

func (c *ProductGetRecommendNameRequest) Execute(accessToken *doudian_sdk.AccessToken) (*product_getRecommendName_response.ProductGetRecommendNameResponse, error) {
	responseJson, err := c.GetClient().Request(c, accessToken)
	if err != nil {
		return nil, err
	}
	response := &product_getRecommendName_response.ProductGetRecommendNameResponse{}
	_ = json.Unmarshal([]byte(responseJson), response)
	return response, nil

}

func (c *ProductGetRecommendNameRequest) GetParamObject() interface{} {
	return c.Param
}

func (c *ProductGetRecommendNameRequest) GetParams() *ProductGetRecommendNameParam {
	return c.Param
}

type SelectPropertyItem struct {
	// 属性id
	Value int64 `json:"value"`
	// 属性名称
	Name string `json:"name"`
}
type ProductGetRecommendNameParam struct {
	// 暂时仅开放一种场景：1. product_name_prefix，表示基于 命中的商品类目属性 推荐 商品标题前缀
	Scene []string `json:"scene"`
	// 商品叶子类目id，scene为product_name_prefix时必传
	CategoryLeafId int64 `json:"category_leaf_id"`
	// 一级类目id，scene为product_name_prefix时必传，没有时传0
	FirstCid int64 `json:"first_cid"`
	// 一级类目名，scene为product_name_prefix时必传
	FirstCidName string `json:"first_cid_name"`
	// 二级类目id，scene为product_name_prefix时必传，没有时传0
	SecondCid int64 `json:"second_cid"`
	// 二级类目名，scene为product_name_prefix时必传
	SecondCidName string `json:"second_cid_name"`
	// 三级类目id，scene为product_name_prefix时必传，没有时传0
	ThirdCid int64 `json:"third_cid"`
	// 三级类目名，scene为product_name_prefix时必传
	ThirdCidName string `json:"third_cid_name"`
	// 商品类目属性
	SelectProperty map[int64][]SelectPropertyItem `json:"select_property"`
}
